Bug 1724271 - Review Request: libmodulemd2 - Module metadata manipulation library
Summary: Review Request: libmodulemd2 - Module metadata manipulation library
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Robert-André Mauchin 🐧
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2019-06-26 15:52 UTC by Stephen Gallagher
Modified: 2019-07-20 01:53 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-07-20 01:53:03 UTC
Type: ---
zebob.m: fedora-review+


Attachments (Terms of Use)

Description Stephen Gallagher 2019-06-26 15:52:17 UTC
Spec URL: https://sgallagh.fedorapeople.org/packagereview/libmodulemd2/libmodulemd2.spec
SRPM URL: https://sgallagh.fedorapeople.org/packagereview/libmodulemd2/libmodulemd2-2.5.0-2.el7.src.rpm
Description:
C Library for manipulating module metadata files.
See https://github.com/fedora-modularity/libmodulemd/blob/master/README.md for
more details.

Fedora Account System Username: sgallagh


Note: this is intended only for EPEL 7.

Comment 1 Robert-André Mauchin 🐧 2019-07-11 23:27:11 UTC
 - Bump to 2.6.0

 - Don't hardcode 36, use %{python3_pkgversion}

 - Source is 404:

Getting https://github.com/fedora-modularity/libmodulemd/releases/download/libmodulemd2-2.5.0/modulemd-2.5.0.tar.xz to ./modulemd-2.5.0.tar.xz
  % Total    % Received % Xferd  Average Speed   Time    Time     Time  Current
                                 Dload  Upload   Total   Spent    Left  Speed
  0     0    0     0    0     0      0      0 --:--:-- --:--:-- --:--:--     0
curl: (22) The requested URL returned error: 404 Not Found

 It should be:

Source0:        %{url}/releases/download/libmodulemd-%{version}/modulemd-%{version}.tar.xz

 - Can't install packages

DEBUG util.py:585:  BUILDSTDERR: Error: 
DEBUG util.py:585:  BUILDSTDERR:  Problem: conflicting requests
DEBUG util.py:585:  BUILDSTDERR:   - nothing provides python3dist(six) needed by python36-libmodulemd2-2.5.0-2.el7.x86_64

Use Requires: python3-six

- ldconfig called in %post and %postun if required.
  Note: /sbin/ldconfig not called in libmodulemd2
  See: https://docs.fedoraproject.org/en-US/packaging-
  guidelines/#_shared_libraries

Use %ldconfig_scriptlets for that
See https://fedoraproject.org/wiki/EPEL:Packaging#Shared_Libraries


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package installs properly.
  Note: Installation errors (see attachment)
  See: https://docs.fedoraproject.org/en-US/packaging-guidelines/
- ldconfig called in %post and %postun if required.
  Note: /sbin/ldconfig not called in libmodulemd2
  See: https://docs.fedoraproject.org/en-US/packaging-
  guidelines/#_shared_libraries


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "Expat License". 274 files have unknown
     license. Detailed output of licensecheck in
     /home/bob/packaging/review/libmodulemd2/review-
     libmodulemd2/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by:
     /usr/lib64/girepository-1.0(gtk2, glade-libs, libgtop2, libgepub,
     gnome-bluetooth-libs, gdk-pixbuf2, atk, gcr, at-spi2-core, gucharmap-
     libs, gtk3, webkitgtk4-jsc, vte3, libpeas, libgnome-keyring, fcitx-
     libs, gspell, libxklavier, libchamplain, libgee06, vte291,
     libmodulemd, gnome-online-accounts, GConf2, gobject-introspection,
     libgee, gstreamer1-rtsp-server, gsound, webkitgtk4, libgdata, grilo,
     libzapojit), /usr/lib64/python2.7/site-packages/gi/overrides(python-
     gobject-base), /usr/lib64/python3.6/site-
     packages/gi/overrides(python36-gobject-base),
     /usr/lib64/python3.6/site-
     packages/gi/overrides/__pycache__(python36-gobject-base),
     /usr/share/gir-1.0(libxklavier-devel, gucharmap-devel, gdk-
     pixbuf2-devel, gnome-bluetooth-libs-devel, libgdata-devel, gobject-
     introspection-devel, gsound-devel, libchamplain-devel, fcitx-devel,
     vte291-devel, libgdl-devel, libgee06-devel, gtk2-devel,
     libgtop2-devel, gcr-devel, libgnome-keyring-devel, gtk3-devel, atk-
     devel, webkitgtk4-jsc-devel, colord-gtk-devel, GConf2-devel,
     libzapojit-devel, totem-pl-parser-devel, vte3-devel, glade-devel,
     libgepub-devel, gstreamer1-rtsp-server-devel, libmodulemd-devel,
     gnome-online-accounts-devel, gspell-devel, at-spi2-core-devel, libgee-
     devel, libpeas-devel, gdm-devel, grilo-devel), /usr/share/gtk-doc(exo-
     devel, webkitgtk3-doc, keybinder-devel, libfm-devel-docs, libgdata-
     devel, gsound-devel, flatpak-devel, libgtop2-devel, xreader-doc,
     harfbuzz-devel, libgda-devel, unique-devel, libzapojit-devel,
     libgnome-devel, libwnck-devel, iio-sensor-proxy-docs, libgit2-glib-
     devel, libmodulemd-devel, libgpod-doc, libxklavier-devel,
     gstreamer1-rtsp-server-devel-docs, intel-gpu-tools, yelp-devel,
     xviewer-doc, xfconf-devel, gtkspell3-devel, libxfce4util-devel,
     libgexiv2-devel, dconf-devel, dbus-doc, upower-devel-docs, anaconda-
     widgets-devel, unique3-docs, gstreamer1-vaapi-devel-docs, tomoe-devel,
     xplayer-doc, gtk3-devel-docs, gimp-devel, xplayer-plparser-doc,
     fprintd-devel, libgweather-devel, ORBit2-devel, gnome-bluetooth-libs-
     devel, clutter-gst3-devel, gedit-devel, cheese-libs-devel, nautilus-
     devel, libnma-devel, eog-devel, libgdl-devel, vte291-devel,
     webkitgtk4-doc, libgnome-keyring-devel, gtk-doc, gnome-desktop3-devel,
     ibus-devel-docs, json-glib-devel, gspell-doc, raptor2-devel, gegl-
     devel, rasqal-devel, gtk2-devel-docs, libidn2-devel, parole-devel,
     gom-devel, poppler-devel, tumbler-devel, libcanberra-devel,
     libu2f-host-devel, libxfce4ui-devel, polkit-docs, redland-devel, xed-
     doc, gcr-devel, libdbusmenu-doc, garcon-devel, libsecret-devel,
     nautilus-python-devel, vte3-devel, gstreamer-plugins-base-devel-docs,
     glade-devel, gnome-desktop-devel, libhif-devel, gtkimageview-devel,
     p11-kit-doc, geocode-glib-devel, libwnck3-devel, libpeas-devel,
     anjuta-devel), /usr/share/gtk-doc/html(exo-devel, webkitgtk3-doc,
     keybinder-devel, libfm-devel-docs, libgdata-devel, gsound-devel,
     flatpak-devel, libgtop2-devel, xreader-doc, harfbuzz-devel, libgda-
     devel, unique-devel, libzapojit-devel, libgnome-devel, libwnck-devel,
     iio-sensor-proxy-docs, libgit2-glib-devel, libmodulemd-devel, libgpod-
     doc, libxklavier-devel, gstreamer1-rtsp-server-devel-docs, intel-gpu-
     tools, yelp-devel, xviewer-doc, xfconf-devel, gtkspell3-devel,
     libxfce4util-devel, libgexiv2-devel, dconf-devel, dbus-doc, upower-
     devel-docs, anaconda-widgets-devel, unique3-docs, gstreamer1-vaapi-
     devel-docs, tomoe-devel, xplayer-doc, gtk3-devel-docs, gimp-devel,
     xplayer-plparser-doc, fprintd-devel, libgweather-devel, ORBit2-devel,
     gnome-bluetooth-libs-devel, clutter-gst3-devel, gedit-devel, cheese-
     libs-devel, nautilus-devel, libnma-devel, eog-devel, libgdl-devel,
     vte291-devel, webkitgtk4-doc, devhelp-devel, libgnome-keyring-devel,
     gnome-desktop3-devel, ibus-devel-docs, json-glib-devel, gspell-doc,
     raptor2-devel, gegl-devel, rasqal-devel, gtk2-devel-docs,
     libidn2-devel, parole-devel, gom-devel, poppler-devel, tumbler-devel,
     libcanberra-devel, libu2f-host-devel, libxfce4ui-devel, polkit-docs,
     redland-devel, xed-doc, gcr-devel, libdbusmenu-doc, garcon-devel,
     libsecret-devel, nautilus-python-devel, vte3-devel, gstreamer-plugins-
     base-devel-docs, glade-devel, gnome-desktop-devel, libhif-devel,
     gtkimageview-devel, p11-kit-doc, geocode-glib-devel, libwnck3-devel,
     libpeas-devel, anjuta-devel)
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Rpmlint is run on all installed packages.
     Note: Mock build failed
     See: https://docs.fedoraproject.org/en-US/packaging-
     guidelines/#_use_rpmlint
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
     Note: Arch-ed rpms have a total of 1751040 bytes in /usr/share
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: libmodulemd2-2.5.0-2.el7.x86_64.rpm
          python2-libmodulemd2-2.5.0-2.el7.x86_64.rpm
          python36-libmodulemd2-2.5.0-2.el7.x86_64.rpm
          libmodulemd2-devel-2.5.0-2.el7.x86_64.rpm
          libmodulemd2-debuginfo-2.5.0-2.el7.x86_64.rpm
          libmodulemd2-2.5.0-2.el7.src.rpm
libmodulemd2.x86_64: W: no-manual-page-for-binary modulemd-validator
python2-libmodulemd2.x86_64: W: obsolete-not-provided python2-modulemd
python2-libmodulemd2.x86_64: W: no-documentation
python36-libmodulemd2.x86_64: W: obsolete-not-provided python3-modulemd
python36-libmodulemd2.x86_64: W: no-documentation
libmodulemd2-devel.x86_64: W: spelling-error Summary(en_US) libmodulemd -> modulated
libmodulemd2-devel.x86_64: W: spelling-error %description -l en_US libmodulemd -> modulated
6 packages and 0 specfiles checked; 0 errors, 7 warnings.

Comment 2 Stephen Gallagher 2019-07-12 18:59:28 UTC
Spec: https://sgallagh.fedorapeople.org/packagereview/libmodulemd2/libmodulemd2.spec
SRPM: https://sgallagh.fedorapeople.org/packagereview/libmodulemd2/libmodulemd2-2.6.0-1.el7.src.rpm
Koji scratch-build: https://koji.fedoraproject.org/koji/taskinfo?taskID=36207323


(As an aside, 2.5.0 was the most recent release when I originally filed this. 2.6.0 was released a week later.)


Thank you for the review!

Comment 3 Robert-André Mauchin 🐧 2019-07-12 19:10:03 UTC
LGTM, package approved.

Comment 4 Gwyn Ciesla 2019-07-12 20:33:51 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/libmodulemd2

Comment 5 Fedora Update System 2019-07-15 14:54:22 UTC
FEDORA-EPEL-2019-90644f2d19 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2019-90644f2d19

Comment 6 Fedora Update System 2019-07-16 02:53:41 UTC
libmodulemd2-2.6.0-1.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2019-90644f2d19

Comment 7 Vít Ondruch 2019-07-16 11:15:55 UTC
It would better if this the updated libmodulemd was kept unversioned and libmodulemd1 was provided for backward compatibility, because it does not look that upstream renamed the library or forked.

Comment 8 Stephen Gallagher 2019-07-16 12:24:18 UTC
(In reply to Vít Ondruch from comment #7)
> It would better if this the updated libmodulemd was kept unversioned and
> libmodulemd1 was provided for backward compatibility, because it does not
> look that upstream renamed the library or forked.

This is an EPEL-only package. In Fedora, what you described already happened; we ship libmodulemd 2.x as libmodulemd and libmodulemd1 for compat.

However, the `libmodulemd` package is in RHEL 7 and provides the 1.x version. We need support in EPEL for 2.x, so it has to come in as libmodulemd2 until and unless RHEL 7 starts carrying both.

For the record, I *am* the upstream.

Comment 9 Vít Ondruch 2019-07-16 13:06:58 UTC
(In reply to Stephen Gallagher from comment #8)
Thx for the explanation. Makes sense. Sorry for the noise.

Comment 10 Fedora Update System 2019-07-17 13:05:57 UTC
FEDORA-EPEL-2019-90644f2d19 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2019-90644f2d19

Comment 11 Fedora Update System 2019-07-18 01:37:51 UTC
libmodulemd2-2.6.0-2.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2019-90644f2d19

Comment 12 Fedora Update System 2019-07-18 20:17:11 UTC
FEDORA-EPEL-2019-90644f2d19 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2019-90644f2d19

Comment 13 Fedora Update System 2019-07-19 02:56:06 UTC
libmodulemd2-2.6.0-3.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2019-90644f2d19

Comment 14 Fedora Update System 2019-07-20 01:53:03 UTC
libmodulemd2-2.6.0-3.el7 has been pushed to the Fedora EPEL 7 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.